-- Demo Project with EGSL
-- 2013 Osgeld
-- Just experimenting with with how much abuse I can 
-- put EGSL through

-- THIS THING GRABS A THREAD AND RUNS WILD WITH IT
-- SO ENJOY THE RIDE OR FORCE CLOSE IT

-- STARTUP
openwindow(640,378,32,"Osgeld's Demo Project")
bgm = loadmusic("kilobyte_mod.xm")
playmusic(bgm, 100,0)
wait(800) -- delay at begining of music

-- TABLES (oh I love tables)
logo    = {}
simpTXT = {}
compTXT = {}
circles = {}
twister = {}

compTXT.star           = {}
compTXT.star.starfield = {}

--GLOBALS
RAD = (math.pi / 180)

-- GENERIC FUNCTIONS
	-- FADE TO BLACK / WHITE
fade = function(color)
	setframetimer(120)

	if color == "white" then 
		for i = 0, 255 do
			backcolour (i,i,i)
			clearscreen() 
			sync()
		end
	else
		for i = 255, 0, -1 do
			backcolour (i,i,i)
			clearscreen() 
			sync()
		end
	end
end

	-- RAINBOW COLOR
getColour = function(angle, channel, place)
	local cos =  math.cos(angle * RAD) * 255
	local sin =  math.sin(angle * RAD) * 255

	if place == "FG" then 
		if channel == 0 then  colour(cos, sin, 0)	
		elseif channel == 1	then  colour(0, cos, sin)
		elseif channel == 2 then  colour(sin, 0, cos)
		end
	else 
		if channel == 0 then  backcolour(cos, sin, 0)	
		elseif channel == 1	then  backcolour(0, cos, sin)
		elseif channel == 2 then  backcolour(sin, 0, cos)
		end
	end
end
-- END GENERIC FUNCTIONS
	
-- Opening Animation (logo)
logo.draw = function()

	local file = io.open("egsl-logo.dat")
	logo.data = {}

	for line in file:lines() do
		table.insert(logo.data, tonumber(line))
	end	
	
	file:close()
	setframetimer(1000)
	for y = 378, 1, -7 do
		for x = 378, 1, -7 do
			colour(logo.data[#logo.data - 2], logo.data[#logo.data - 1], logo.data[#logo.data])
			fillbox (x + 120, 1, (x+127), y)
			sync()
			for i = 1, 3 do
				table.remove(logo.data, #logo.data)
			end
		end
	end
	
	wait(5000)
	colour(0, 0, 0)
	setframetimer(225)
	
	for y = 378, 1, -7 do
		for x = 1, 387, 7 do
			fillbox ((x+127), y - 7, x, y)
			sync()
		end
	end
end

-- Simple Text Scroller
simpTXT.draw = function()

	colour(255, 255, 255)
	setframetimer(60)
	
	for x = 640, -980, -1 do
		clearscreen()
		drawtext (x ,181 ,"Hello World, this is my Demo project with EGSL and so far it seems quite fun, but this sucks, so lets spice it up a bit!")
		sync()
	end
end

-- Complicated Text Scroller
compTXT.star.make = function(i)
        compTXT.star.starfield[i] = {}
        compTXT.star.starfield[i].x = math.random(2*640) - 640
        compTXT.star.starfield[i].y = math.random(2*378) - 378
        compTXT.star.starfield[i].z = 5
end

compTXT.star.update = function()
    for i = 1, 200 do
        compTXT.star.starfield[i].z = compTXT.star.starfield[i].z - 0.05
        if compTXT.star.starfield[i].z < 0.05 then 
			compTXT.star.make(i)
		end
        
		x = 640 / 2 + compTXT.star.starfield[i].x / compTXT.star.starfield[i].z
        y = 378 / 2 + compTXT.star.starfield[i].y / compTXT.star.starfield[i].z
        if x < 0 or y < 0 or x >= 640 or y >= 378 then
			compTXT.star.make(i)
		else
			fillcircle(x,y,1)
        end
    end
end

compTXT.draw = function()

	setframetimer(60)
	for i = 1, 200 do
        compTXT.star.make(i)
        compTXT.star.starfield[i].z = math.random(5)
	end
	
	local angle = 0
	local channel = 0
	local x = 640
	local hacky = "This is a bit more wild, don't you think? Lets see what other hacky stuff I can come up with."
	while timerticks() < 38250 do 
		if angle == 90 then
			angle = 0
			if channel ~= 2 then channel = channel + 1
				else channel = 0
			end
		end
		getColour(angle,channel,"FG")
		clearscreen()
		compTXT.star.update()
		colour(255,255,255)
		drawtext (x ,1 , hacky)
		drawtext (-640 + (640 - x) ,370 , hacky)
		sync()
		angle = angle + 1
		x = x - 1
	end
end

-- Interference circle scene 
circles.draw = function()

	setframetimer(30)
	colourkey(255,0,255)
	circles.img = loadimage("circles.png")	
	
	local x = -80
	local y = -111
	radius = 15
	while timerticks() < 52000 do 
		for r = 1, 60 do 		
			clearscreen() 
			local rx = x + math.sin(r * 0.1) * radius
			local ry = y - math.cos(r * 0.1) * radius
			putimage(x,y,circles.img)
			putimage(rx,ry,circles.img)
			sync()
		end
	end
	
	radius  = 100
	channel = 0
	angle   = 0 
	
	while timerticks() < 63000 do
		for r = 1, 120 do 	
			if angle == 90 then
				angle = 0
				if channel ~= 2 then channel = channel + 1
				else channel = 0
				end
			end 
			
			angle = angle + 0.5
			getColour(angle,channel,"BG")
			
			clearscreen() 
			local rx = x + math.sin(r * 0.05)  * radius
			local ry = y - math.cos(r * 0.05)  * radius
			local tx = x + math.sin(r * -0.05) * radius
			local ty = y - math.cos(r * -0.05) * radius
			putimage(tx,ty,circles.img)
			putimage(rx,ry,circles.img)
			sync()
		end	
	end
end


twister.draw = function()

	setframetimer(10)
	twister.img = loadimage("sam.png")
	
	for i = 10, 1, -0.1 do
		local newimage = zoomimage(twister.img, i, 1)
		putimage(0,0,newimage)
		sync()
	end
	mode = 0
	an = 1
	am = 0.1
	x1 = 0
	x2 = 0
	x3 = 0
	x4 = 0
	
	for a = 1, 378,5 do
		x1 = (math.sin((a / am) + an) * 100)        + 120
		x2 = (math.sin((a / am) + an + 90) * 100)   + 120
		x3 = (math.sin((a / am) + an + 90*2) * 100) + 120
		x4 = (math.sin((a / am) + an + 90*3) * 100) + 120
			
		colour(128,0,0)
		if x1 < x2 then
			fillbox(x1 ,a ,x2 ,a + 5)
		end
		
		colour(0,0,128)			
		if x2<x3 then
			fillbox(x2, a, x3, a + 5)
		end
		
		colour(0,128,0)		
		if x3 < x1 then
			fillbox(x3, a, x1, a + 5)
		end
		
		an = an - 0.0001
		wait(100)
		sync()
	end
		
	
	while timerticks() < 78000 do end
	
	setframetimer(60)
	
	while timerticks() < 90700 do

		putimage(0,0, twister.img)
		for a = 1, 378,5 do
			x1 = (math.sin((a / am) + an) * 100)        + 120
			x2 = (math.sin((a / am) + an + 90) * 100)   + 120
			x3 = (math.sin((a / am) + an + 90*2) * 100) + 120
			x4 = (math.sin((a / am) + an + 90*3) * 100) + 120
			
			colour(128,0,0)
			if x1 < x2 then
				fillbox(x1, a, x2, a + 5)
			end
		
			colour(0,0,128)			
			if x2<x3 then
				fillbox(x2, a, x3, a + 5)
			end
		
			colour(0,128,0)		
			if x3 < x1 then
				fillbox(x3, a, x1, a + 5)
			end
			
			colour(0,128,0)		
			if x4 < x1 then
				fillbox(x4, a, x1, a + 5)
			end
		
			an = an - 0.0001
		end
		sync()
	end
	
	while timerticks()  < 102500 do
		putimage(0,0, twister.img)
		for a = 1, 378,5 do
			x1 = (math.sin((a / am) + an) * 100)        + 120
			x2 = (math.sin((a / am) + an + 90) * 100)   + 120
			x3 = (math.sin((a / am) + an + 90*2) * 100) + 120
			x4 = (math.sin((a / am) + an + 90*3) * 100) + 120
			
			colour(128,0,0)
			if x1 < x2 then
				fillbox(x1, a, x2, a + 5)
			end
		
			colour(0,0,128)			
			if x2<x3 then
				fillbox(x2, a, x3, a + 5)
			end
		
			colour(0,128,0)		
			if x3 < x1 then
				fillbox(x3, a, x1, a + 5)
			end
			
			an = an - 0.0001
		end
		sync()
		
		am = am + 0.5
	end
end

--Raytracing

raytraceInit = function()
	colour(0,255,96)
	screen_width   = 640
	screen_height  = 378
	feild_of_view  = 060 -- degrees
	sliver_width   = 04 -- thickness of wall sliver in pixels
	wall_zoom      = 200 -- how much to zoom the walls
	ray_resolution = 0.05

	slivers_per_screen = math.ceil(screen_width / sliver_width)
	ang_per_sliver = feild_of_view / slivers_per_screen
	pibt = (math.pi / 180)
	fovbt = (feild_of_view / 2)

	-- map data
	map_width  = 11
	map_height = 11
	map_start_point_x = 2.5
	map_start_point_y = 2.5
	map_start_angle   = 90
	map =
	{
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1},
		{1, 0, 1, 0, 0, 0, 1, 1, 1, 0, 1},
		{1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1},
		{1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 1},
		{1, 0, 1, 1, 1, 0, 1, 0, 1, 0, 1},
		{1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1},
		{1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1}
	}

	-- player data
	player_speed  = 0.02
	player_turn   = 1
	player_x = map_start_point_x
	player_y = map_start_point_y
	player_ang = map_start_angle
	
	counter = 1 -- for computer controlled movement
end

get_map = function(x, y)
	x = math.floor(x)
	y = math.floor(y)
	
	if (x < 1 or y < 1) or (x > map_width or y > map_height) then
		return 1
	end

	return map[y][x]
end

cast_ray = function(x, y, ang)
	local distance = 0
	local dx = math.cos(ang * pibt) * ray_resolution
	local dy = math.sin(ang * pibt) * ray_resolution
	
	repeat
		x = x + dx
		y = y + dy
		distance = distance + ray_resolution
		col = get_map(x, y)
		if (col ~= 0) then 
			break
		end
	until (false)
	
	return distance, col
end



raytrace = function()

	while timerticks() < 117500 do
		local ox = player_x
		local oy = player_y
		clearscreen() 
		if counter < 307 then
			player_x = player_x + math.cos(player_ang * pibt) * player_speed
			player_y = player_y + math.sin(player_ang * pibt) * player_speed

		elseif counter < 400 then
			player_ang = (player_ang + 360 - player_turn) % 360
			
		elseif counter < 600 then
			player_x = player_x + math.cos(player_ang * pibt) * player_speed
			player_y = player_y + math.sin(player_ang * pibt) * player_speed
			
		elseif counter < 690 then
			player_ang = (player_ang + 360 - player_turn) % 360
		
		elseif counter < 980 then
			player_x = player_x + math.cos(player_ang * pibt) * player_speed
			player_y = player_y + math.sin(player_ang * pibt) * player_speed
		elseif counter < 1075 then
			player_ang = (player_ang + player_turn) % 360
			
		elseif counter < 1290 then
			player_x = player_x + math.cos(player_ang * pibt) * player_speed
			player_y = player_y + math.sin(player_ang * pibt) * player_speed
		
		elseif counter < 1375 then
			player_ang = (player_ang + player_turn) % 360
		
		elseif counter < 1650 then
			player_x = player_x + math.cos(player_ang * pibt) * player_speed
			player_y = player_y + math.sin(player_ang * pibt) * player_speed
			
		elseif counter < 1740 then
			player_ang = (player_ang + player_turn) % 360
		
		elseif counter < 1840 then
			player_x = player_x + math.cos(player_ang * pibt) * player_speed
			player_y = player_y + math.sin(player_ang * pibt) * player_speed
			
		elseif counter < 2050 then
			player_ang = (player_ang + player_turn) % 360
		
		end
		

		--	elseif down() then
		--		player_x = player_x - math.cos(player_ang * pibt) * player_speed
		--		player_y = player_y - math.sin(player_ang * pibt) * player_speed
		--	end
	
		--	if right() then
		--		player_ang = (player_ang + player_turn) % 360
	
		--	elseif left() then
		--		player_ang = (player_ang + 360 - player_turn) % 360
		--	end	
		--
	
		-- check bounds
		if (get_map(player_x, player_y) ~= 0) then
			player_x = ox
			player_y = oy
		end

		-- cast rays	
		local sx = 0
		local ang = player_ang - fovbt
		local ray_len = 0
		local col = 0
		local height = 0
		local start_wall = 0
	
		-- start from the left and cast a ray per sliver
		for s = 1, slivers_per_screen do
			-- cast the ray
			ray_len, col = cast_ray(player_x, player_y, ang)
			ray_len = ray_len *  math.cos((player_ang - ang) * pibt)

			-- calulate wall height
			height = math.floor(wall_zoom / ray_len)
			start_wall = math.floor(136 - height / 2)
		
			-- clip the wall to the screen
			if (start_wall < 0) then
				height = height + start_wall
				start_wall = 0
			end
		
			if (start_wall + height > screen_height) then
				height = screen_height - start_wall
			end

			-- draw the wall
			box(sx, start_wall,  sx + sliver_width, start_wall + height)
			-- increase the sliver pos
			sx = sx + sliver_width
			-- increase the sliver angle
			ang = ang + ang_per_sliver
		end
		
		sync()
		counter = counter + 1
	end
end

-- static effect
static = function()
	setframetimer(1000)
	
	while timerticks() < 117900 do
		for y = 1, 378, 6 do
			for x = 1, 640, 16 do
				c = math.random(2)
				
				if c == 1 then 	colour(255, 255, 255)
				else colour(0, 0, 0) end
				
				fillbox(x, y, x + 16, y + 6)
			end
			sync()
		end
	end
end

ending = function()
	colour(0, 0, 0)
	drawtext(312,181, "END")
	sync()
	while timerticks() < 125000 do end
end


logo.draw()
simpTXT.draw()
compTXT.draw()
fade("white")
circles.draw()
fade("black")
twister.draw()
fade("black")
raytraceInit()
raytrace()
static()
fade("white")
ending()
closewindow()